#include "custom_plugin.h"

Custom_plugin::Custom_plugin()
{
    name = "custom";
    if(QLocale::system().name() == "fr_FR"){genericName = "Commande Personnalisé";}
    else{genericName = "Custom Command";}
    icon = QIcon("/usr/share/icons/elementary-xfce/apps/24/utilities-terminal.png");
}

QString Custom_plugin::getName()
{
    return name;
}

QString Custom_plugin::getGenericName()
{
    return genericName;
}

QIcon Custom_plugin::getIcon()
{
    return icon;
}

QString Custom_plugin::getCommand()
{
    if(chkRoot->isChecked())
        return "sudo " + command;
    else
        return command;
}

void Custom_plugin::getPluginConfig(QVBoxLayout *info)
{
    QLabel *lblCmd = new QLabel("Enter a command");
    txtCmd = new QLineEdit();
    chkRoot = new QCheckBox("Run as Root");

    if(QLocale::system().name() == "fr_FR"){
        lblCmd->setText("Entrer une commande");
        chkRoot->setText("Exécuter à la racine");
    }

    QHBoxLayout *layout = new QHBoxLayout();
    layout->addWidget(lblCmd);
    layout->addWidget(txtCmd);

    info->addLayout(layout);
    info->addWidget(chkRoot);
}

Plugin* Custom_plugin::writeConfig()
{
    command = txtCmd->text();
    QString newFile = "[" + name + "]\n"
              "command=" + command + "\n";
    if(chkRoot->isChecked())
        newFile += "as_root=true\n";
    else
        newFile += "as_root=false\n";
    newFile += "\n";
    QFile file(CONFFILE);
    if(file.open(QFile::ReadWrite |
                  QFile::Text))
    {
        bool keep = true;
        QTextStream in(&file);
        while (!in.atEnd())
        {
          QString line = in.readLine();
          if(line == "[" + name + "]")
              keep = false;
          if(keep)
              newFile += line + "\n";
          if(line == "")
              keep = true;

        }
        file.close();
        if(file.open(QFile::WriteOnly | QIODevice::Truncate |
                      QFile::Text))
        {
            QTextStream out(&file);
            out << newFile;
            file.flush();
            file.close();
        }
    }

    return this;
}

void Custom_plugin::readConfig()
{
    QFile file(CONFFILE);
    if(file.open(QFile::ReadOnly |
                  QFile::Text))
    {
        bool parse = false;
        QTextStream in(&file);
        while (!in.atEnd())
        {
          QString line = in.readLine();
          if(line == "")
              parse = false;
          if(line == "[" + name + "]")
              parse = true;

          QStringList list = line.split("=");
          if((list.at(0) == "command") && parse)
          {
              txtCmd->setText(list.at(1));
          }
          if((list.at(0) == "as_root") && parse)
          {
              chkRoot->setChecked(list.at(1) == "true");
          }
        }
        file.close();
    }
}
